
2 REM Adapted to KB9 from IBM BASIC by Dave Hassler, 2023

5 E$=CHR$(27)+CHR$(91):CL$=E$+"2J":RV$=E$+"7m":NO$=E$+"m"
8 PRINTCL$:PRINT"  KNIGHTSBRIDGE by Tim Hartnell, 1983"
10 DIM H(99),Z(8):POKE10920,169
12 PRINT:INPUT"Instructions (Y/N)";I$
13 IFLEFT$(I$,1)<>"Y"THEN20

15 PRINT:GOTO1000:REM Instructions
20 GOTO760:REM Initialise
40 IFHU=5ORCO=5THEN680: REM End of game
50 GOSUB300:REM Computer moves
60 GOSUB490:REM Print board

70 IFHU=5ORCO=5THEN680:REM End of game
80 GOSUB110
90 GOTO40
100 REM
110 REM Player moves
120 Q=0
130 M=INT(RND(1)*66)+11
140 Q=Q+1
150 IFQ=500THEN680
160 IFH(M)<>72THEN130
170 PRINT"You must move the piece on";M
180 INPUTN
190 IFN=99THENQ=500:GOTO 680
200 REM *** Check if move legal ***
210 P=0:CT=1
220 L=M+Z(CT)
230 IFL<>NTHEN240
235 IFH(N)=46ORH(N)=67THENP=1
240 IFCT<8THENCT=CT+1:GOTO 220
250 IFP=0THENPRINT"Illegal move":GOTO 180
260 IFH(N)=67THENHU=HU+1:PRINTRV$;"Well played!";NO$
265 FORI=1TO1500:NEXT
270 H(M)=46:H(N)=72
280 RETURN
290 REM
300 REM Computer
310 Q1=0
320 Q1=Q1+1
330 K=INT(RND(1)*66)+11
340 IFQ1=500THEN680
350 IFH(K)<>67THEN320
360 PRINTCL$;"I had to move the piece on";K;
370 W=1
380 IFK+Z(W)<11ORK+Z(W)>77THEN400
390 IFH(K+Z(W))=72THENFL=1:CO=CO+1
395 IFH(K+Z(W))=72THEN450
400 IFW<8THENW=W+1:GOTO380
410 W=1
420 IF(K+Z(W)<11ORK+Z(W)>77)ANDW<8THENW=W+1:GOTO420
430 IFH(K+Z(W))<>46ANDW<8THENW=W+1:GOTO430
440 IFW=8ANDH(K+Z(W))<>46THENQ1=500:GOTO680
450 X=K:Y=K+Z(W)
460 H(X)=46:H(Y)=67:PRINT"and went to";Y
465 IFFL=1THENPRINTRV$;"Gotcha!";NO$:FL=0
470 RETURN
480 REM
490 REM Print board
500 PRINT
510 PRINT TAB(8);"My score:  ";CO
520 PRINT TAB(8);"Your score:";HU
530 PRINT
540 PRINT TAB(8);"1 2 3 4 5 6 7"
550 PRINT TAB(8);"-------------"
560 FORM=70TO10STEP-10
570 PRINTTAB(5);M/10;
580 FORN=1TO7
590 PRINTCHR$(H(M+N));" ";
600 NEXTN
610 L$=STR$(M/10):L$=RIGHT$(L$,1)
615 PRINTL$
620 NEXTM
630 PRINT TAB(8);"-------------"
640 PRINT TAB(8);"1 2 3 4 5 6 7"
650 PRINT
660 RETURN
670 REM
680 REM End of game
700 IFHU=5THENPRINT"You have beaten me, human. We shall retreat."
710 IFCO=5THENPRINT"This victory is the first step in our plan"
715 IFCO=5THENPRINT"to take over the entire Earth!"
720 IFQ=500THENPRINT"I accept your wish to concede...slave."
730 IFQ1=500THENPRINT"I concede to a Master. We will leave."
740 END
750 REM
760 REM Initialise
770 PRINT:PRINT"Stand by...puny human."
780 FORI=1TO1000:NEXT
790 X=0:Q1=0:Q=0
810 HU=0:CO=0:REM Scores

820 FORA=10TO70STEP10:FORB=1TO7:H(A+B)=46:NEXTB:NEXTA
822 FORB=1TO7:H(70+B)=67:H(10+B)=72:NEXTB

890 FORA=1TO8:READZ(A):NEXTA
900 DATA -8,-21,-12,-19,19,12,21,8
910 GOTO50

1000 PRINT"   The fate of your planet rests with you, puny human."
1010 PRINT"All of your pieces (H) are knights; my knights are (C)."
1015 PRINT"The galactic core computer NIVRAM will randomly select"
1017 PRINT"which piece each of us shall move."
1020 PRINT"   The first player to capture five of the opponent's"
1030 PRINT"knights wins Earth.  Enter '99' if you cannot move."
1032 PRINT"   May mighty Tor'ra grant me victory!"
1035 PRINT:INPUT"Hit <RET> to start --> ";I$
1040 GOTO20

